//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsflushbuffers.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"





int FSFlushBuffers(FS_FILE *file)
{
int error;
FS_VOLUME *fs;

// FINISH A WRITING SESSION

error=FSVolumePresent(FSystem.Volumes[file->Volume]);
if(error!=FS_OK) { return error; }


if(file->Mode&FSMODE_WRITE) {
// TO DO:
// FLUSH WRITE BUFFERS

if(!(file->Mode&FSMODE_MODIFY)) {
error=FSTruncateChain(file,file->FileSize);	// TRUNCATE CHAIN UNLESS IN MODIFY MODE
if(error!=FS_OK) return error;
}

}

// WRITE UPDATED DIRECTORY ENTRY IF FILE HAS CHANGED
if(file->Dir) {
error=FSUpdateDirEntry(file);
if(error!=FS_OK) return error;
}



fs=FSystem.Volumes[file->Volume];

// FLUSH ALL FAT CHAINS
error=FSFlushFATCache(fs);
if(error!=FS_OK) return error;


return FS_OK;
}
