//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsopendir.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"



// OPEN DIRECTORIES FOR ENTRY SCANNING

int FSOpenDir(char *name,FS_FILE **fileptr)
{
FS_FILE *entry,*old;
int error;
FS_VOLUME *fs;


error=FSInit();
if(error!=FS_OK) return error;


entry=(FS_FILE *)malloc(sizeof(FS_FILE));
if(entry==NULL) return FS_ERROR;

// CLEAN ENTRY
memset((void *)entry,0,sizeof(FS_FILE));


// CHECK IF CARD IS PRESENT

error=FSVolumePresent(FSystem.Volumes[FSystem.CurrentVolume]);
if(error!=FS_OK) { free(entry); return error; }



error=FSFindFile(name,entry,TRUE);

if((error!=FS_OK) && (error!=FS_OPENDIR)) { free(entry); return error; }

if(error==FS_OK) {
// NEWLY OPENED DIR
if(!(entry->Attr&FSATTR_DIR)) {
// CLEANUP PROCEDURE
while(entry!=NULL) entry=FSFreeFile(entry);
return FS_NOTFOUND;
}

fs=FSystem.Volumes[entry->Volume];

// GET FILE CLUSTER CHAIN
error=FSGetChain(entry->FirstCluster,&entry->Chain,fs);

if(error!=FS_OK) {
while(entry!=NULL) entry=FSFreeFile(entry);
return FS_ERROR;
}
entry->FileSize=FSGetChainSize(&entry->Chain);

entry->Mode=FSMODE_READ;


}
else {
// USE AN ALREADY OPENED DIRECTORY
old=entry;
entry=entry->Dir;
free(old);
if(!(entry->Attr&FSATTR_DIR)) {
// CLEANUP PROCEDURE
return FS_NOTFOUND;
}

fs=FSystem.Volumes[entry->Volume];
//printf("fs=%08X\n",(unsigned int)fs);
}





for(error=0;error<FS_MAXOPENFILES;++error)
{
if(fs->Files[error]==NULL) break;
}

if(error==FS_MAXOPENFILES) {
while(entry!=NULL) entry=FSFreeFile(entry);
return FS_MAXFILES; 
}


fs->Files[error]=entry;
*fileptr=entry;
entry->CurrentOffset=0;
return FS_OK;
}
