//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

#include <hpgcc3.h>
extern "C" {
#include <ggl.h>
}

#include "memblock.h"
#include "gstring.h"
#include "gui.h"
#include "resources.h"


BOOL gOKEvent(gEvent *e,gControl *This)
{
	This->GetApplication()->Terminate(0);
	return TRUE;
}
BOOL gCancelEvent(gEvent *e,gControl *This)
{
	This->GetApplication()->Terminate(-1);
	return TRUE;
}
BOOL gDoNothingEvent(gEvent *e,gControl *This)
{
	return FALSE;
}

gMsgBoxResult gDoMessageBox(gApplication *app,const char *Title,const char *Message,gMsgBoxStyle Flags)
{
	int x,y;
	int width;
	int height;
	int Style;
	int result;
	
	// DETERMINE SIZE OF TEXT
	gFont ff(5);	
	gStaticTextWrap::CalcSize(Message,&ff,110,&width,&height);
	
	int titlewidth=ff.TextWidth((char *)Title);
	if(titlewidth>110) titlewidth=110;
	if( (width<titlewidth)) width=titlewidth;
	
	
	// DETERMINE TYPE OF EXISTING MENU
	
	if(app->CurrentForm) {
		Style=((gForm *)(app->CurrentForm))->StyleFlags&(S_SINGLESOFTMENU | S_EXSOFTMENU) ;
	}
	
	else Style=S_SINGLESOFTMENU;

	
	gForm *MsgBox;
	
	if(height>40) {
		x=(USERSCREEN_W-(width+SCROLLBARWIDTH+2*BORDERWIDTH+4))/2;
		y=USERSCREEN_H;
		if(Style&S_SINGLESOFTMENU) y-=SOFTMENUHEIGHT;
		else if(Style&S_EXSOFTMENU) y-=3*SOFTMENUHEIGHT;
		y-=40;
		y/=2;
		MsgBox=new gForm(*app,Title,(gFormStyles) (S_TOPCAPTION | S_HASBORDER | S_SHADE | S_FORCEVSCROLL),x,y,width+SCROLLBARWIDTH+2*BORDERWIDTH+4,40,width+4,height+4);
	}
	else {
		x=(USERSCREEN_W-(width+2*BORDERWIDTH+4))/2;
		y=USERSCREEN_H;
		if(Style&S_SINGLESOFTMENU) y-=SOFTMENUHEIGHT;
		else if(Style&S_EXSOFTMENU) y-=3*SOFTMENUHEIGHT;
		y=height+4+2*BORDERWIDTH+CAPTIONHEIGHT;
		y=USERSCREEN_H-y;
		y/=2;
		MsgBox=new gForm(*app,Title,(gFormStyles) (S_TOPCAPTION | S_HASBORDER | S_SHADE ),x,y,width+2*BORDERWIDTH+4,height+4+2*BORDERWIDTH+CAPTIONHEIGHT);
	}
	

	{	// CREATE CONTROLS WITH LIMITED SCOPE
	
	gSoftMenu MsgMenu(*MsgBox,Style);
	
	switch(Flags)
	{
	case S_RETRYCANCEL:
		MsgMenu.AddItem("RETRY",&gOKEvent);
		break;
	case S_YESNO:
		MsgMenu.AddItem("YES",&gOKEvent);
		break;
	case S_OKONLY:
		MsgMenu.AddItem("",&gDoNothingEvent);
		break;
	case S_OKCANCEL:
	default:
		MsgMenu.AddItem("OK",&gOKEvent);
	}
	
	MsgMenu.AddItem("",&gDoNothingEvent);
	MsgMenu.AddItem("",&gDoNothingEvent);
	MsgMenu.AddItem("",&gDoNothingEvent);
	MsgMenu.AddItem("",&gDoNothingEvent);
	
	switch(Flags) {
	case S_OKONLY:
		MsgMenu.AddItem("OK",&gOKEvent);
		break;
	case S_YESNO:
		MsgMenu.AddItem("NO",&gCancelEvent);
		break;
	case S_OKCANCEL:
	case S_RETRYCANCEL:
	default:
		MsgMenu.AddItem("CANCEL",&gCancelEvent);
		break;
	}
	

	gStaticTextWrap Msg(*MsgBox,2,2,width ,Message,&ff,GBLACK);

	
	
	app->OpenNewForm(MsgBox);
	
	result=app->RunInternalLoop();
	
	}	// DESTROY ALL CONTROLS (OUT OF SCOPE)
	
	delete MsgBox;	// DESTROY MAIN FORM
	
	return (gMsgBoxResult)result;
}


