//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <hpgcc3.h>
#include "hpgraphics.h"
#include "hpgpriv.h"
#include <master_globals.h>


// CHANGED BY CLAUDIO - Apr 2005
/* THE LCD CONTROLLER SEEMS TO HAVE PROBLEMS
   WHEN ADDRESSES END WITH 0xC AND 0x8
   REASON IS UNKNOWN BUT THE WORKAROUND IS
   TO GUARANTEE THAT FRAME BUFFER IS ALWAYS
   ALIGNED IN 0x0 (MULTIPLE OF 4 WORDS)
*/

static char *align_fb(char *mem)
{
    int fbval = (int) mem;
    fbval = (fbval + 15) & 0xFFFFFFF0;
    return (char *) fbval;
}

void _hpg_set_mode(int mode, char *visfb, char *drawfb, 
    void (*drawfn)(hpg_t *, int, int, int, int, int),
    unsigned char (*getfn)(hpg_t *, int, int))
{

    char *orgvisfb=visfb,*orgdrawfb=drawfb;
    char *finalbuffer;
    int linewidth;

    if (visfb != DEFAULT_PLANE)
    {
        finalbuffer = visfb = (char *) sys_map_v2p((unsigned int) align_fb(visfb));
    }
    else finalbuffer= (char *)((__mg->__console_vars->__display_buf&0xfffff)|0x40000000);


    drawfb = (char *) sys_map_v2p((unsigned int) align_fb(drawfb));


    lcd_sync();


    // HARDWARE CODE REMOVED BY CLAUDIO

    linewidth=lcd_setmode(mode,(int *)finalbuffer);


     /*
     * Update graphics context state so the library knows how to
     * deal with the current graphics mode.
     */

    if (__mg->hpg_stdscreen->fb != DEFAULT_PLANE)
    {
        free((char *) __mg->hpg_stdscreen->org_fb1);
    }

    if ((__mg->hpg_stdscreen->drawfb != DEFAULT_PLANE)
        && (__mg->hpg_stdscreen->drawfb != __mg->hpg_stdscreen->fb))
    {
        free((char *) __mg->hpg_stdscreen->org_fb2);
    }

    __mg->hpg_stdscreen->org_fb1=orgvisfb;
    __mg->hpg_stdscreen->org_fb2=orgdrawfb;
    __mg->hpg_stdscreen->fb = visfb;
    __mg->hpg_stdscreen->drawfb = drawfb;
    __mg->hpg_stdscreen->fbwidth = linewidth;
    __mg->hpg_stdscreen->drawfn = drawfn;
    __mg->hpg_stdscreen->getfn = getfn;
}
