//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <stdlib.h>
#include <sys.h>
#include "hpgraphics.h"
#include "hpgpriv.h"
#include <master_globals.h>




/*
 * Initialization code for the screen
 */
void hpg_init(void)
{
    if (__mg->inited) return;

    hpg_t *main_hpg = malloc(sizeof(hpg_t));
    if(!main_hpg) return;

    __mg->inited = 1;

    __mg->hpg_stdscreen = main_hpg;

    main_hpg->fb = main_hpg->org_fb1 = main_hpg->org_fb2 = DEFAULT_PLANE;
    main_hpg->drawfb = DEFAULT_PLANE;
    main_hpg->width = SCR_WIDTH;

    // FIXED BY CLAUDIO - MULTIPLE CALC SUPPORT
    main_hpg->height = lcd_getheight();
    main_hpg->clipx1 = 0;
    main_hpg->clipy1 = 0;
    main_hpg->clipx2 = main_hpg->width;
    main_hpg->clipy2 = main_hpg->height;
    main_hpg->mode = HPG_MODE_PAINT;
    main_hpg->color = HPG_COLOR_BLACK;
    main_hpg->pattern = NULL;
    main_hpg->fbwidth = 0x14;
    main_hpg->drawfn = _hpg_mono_draw;
    main_hpg->getfn = _hpg_mono_get;
    main_hpg->font=hpg_get_minifont();
    

    atexit(hpg_cleanup);
}

void hpg_cleanup(void)
{
    if (!__mg->inited) return;

    if (__mg->hpg_stdscreen->org_fb1 != DEFAULT_PLANE)
    {
        free(__mg->hpg_stdscreen->org_fb1);
    }

    if ((__mg->hpg_stdscreen->org_fb2 != DEFAULT_PLANE)
        && (__mg->hpg_stdscreen->org_fb2 != __mg->hpg_stdscreen->org_fb1))
    {
        free(__mg->hpg_stdscreen->org_fb2);
    }
    __mg->inited = 0;
    free(__mg->hpg_stdscreen);
    __mg->hpg_stdscreen=NULL;
}
