//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// ROMLIB CHECKED


#define ALIGN4(x) (((unsigned)(x)+3) & 0xFFFFFFFCU)

#include <stdlib.h>
#include <master_globals.h>



// Changed overflow/stack collision checking method to manually calculating virtual stack pointer address.
// According to Claudio's instructions in his mail from 2004-10-05
// [ibl 04/10/05]

// Changed back to virtual stack pointer comparison, suitable for new "memory packing" loader
// <ibl; 2004-11-07>

int
_brk(char *top)
{
    
    register unsigned int stack_ptr asm("sp");
    
    
    if (top < (char *) stack_ptr && top > (char *)__mg->_heap_base_addr) {
        __mg->__heap_ptr = (char *) ALIGN4(top);
        return 0;
    }
    else
        return -1;
}

int
brk(char *top)
{
    return _brk(top);
}


char *
sbrk(int incr)
{    
    char *base,*new_heap;
    register unsigned int stack_ptr asm("sp");
    
    
    if (__mg->__heap_ptr == 0)         
        __mg->__heap_ptr = (char *)__mg->_heap_base_addr;
    
    base = __mg->__heap_ptr;
    
    new_heap = (char *)ALIGN4(__mg->__heap_ptr + incr);
    
    if ((new_heap > (char *) stack_ptr) ||  (new_heap < (char *)__mg->_heap_base_addr))
        return (char *) -1;
    
    __mg->__heap_ptr = new_heap;
    return base;

}

char *
_sbrk(int incr)
{
    return sbrk(incr);
}



    
    
