//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include <sys.h>
#include <stdlib.h>

// ROMLIB CHECKED


int
sys_mem_classify(int addr)
{
    int r,a = (addr >> 16) & 0xf;
    
    // 0 OR 1 --> SYSTEM MEMORY
    // 2 OR 3 --> PORT1
    // 4 THRU 7 --> MAIN RAM
    
    if (a < 2)
        r = 0;
    else if (a > 3)
        r = 2;
    else
        r = 1;
        
    return r;
}


static int
is_continuous(void *ptr, int size)
{
    int start = sys_map_v2p((int)ptr);
    int end   = sys_map_v2p((int)ptr+size);
    
    return(sys_mem_classify(start)==sys_mem_classify(end));

}

// TODO: unit test, stress test

void
*sys_phys_malloc(size_t size)
{
    #define TRIES 5
    void *p[TRIES];
    int i,tries = 0;
    
    do {
        p[tries] = malloc(size);
        if(is_continuous(p[tries],size)) 
            break;
    } while (++tries < TRIES);
    
    for(i = 0; i < tries; i++)
        free(p[i]);

    if(tries < TRIES) {
        // ADDED FLUSH CACHES ON VIRTUAL ADDRESSES - CLAUDIO 01/09/05

        //<benjamin;28/08/05>
        //temporarly removed for thumb compatibility 
		// ACTIVATED BACK - CLAUDIO MARCH 2006

        cpu_flush_cache(p[tries],size);

        return p[tries];
    }
    else return NULL;
    
    
}




